# Filters added to this controller apply to all controllers in the application.
# Likewise, all the methods added will be available for all controllers.

class ApplicationController < ActionController::Base
  # Pick a unique cookie name to distinguish our session data from others'
  session :session_key => '_profile_session_id'
  
  def check_authentication
    unless session[:user]
      redirect_to(signin_url)
    end
  end
  
  def get_user
    if session[:user]
      @user = User.find(session[:user])
    end
  end
  
  def handy_get(url,timeout=3)
    uri = URI.parse(url)
    begin
      http = Net::HTTP.new(uri.host,uri.port)
    rescue SocketError
      return {
        :status => "fail",
        :body => ""
      }
    end
#    logger.info(["host:",uri.host])
#    logger.info(["port:",uri.port])
#    logger.info(["path:",uri.path])
#    logger.info(["query:",uri.query])
    path=uri.path
    if uri.query
      path=uri.path+"?"+uri.query
    end
    logger.info(["combined path:",path])
    g = Net::HTTP::Get.new(path)
    http.read_timeout = timeout

    begin
      res = http.start { |web| 
        web.request(g) 
      }
    rescue Timeout::Error, Errno::ETIMEDOUT
      return {
        :status => "fail",
        :body => ""
      }
    else
      logger.info(["g:",g])
      logger.info(["http:",http])
      logger.info(["res:",res])
      return {
        :status => "ok",
        :body => res.body
      }
    end
  end
  
  
end
