require "mofo" 

class SigninController < ApplicationController  
  layout "profile"
  def index
    
  end
  
  def signin
    @page_id = "page-signin-openid"
    if params[:ret]
      session[:intended_url] = params[:ret]
    end
    
    if session[:user] && session[:intended_url]
      redirect_to session[:intended_url]
    end
    if session[:user] && session[:intended_action] && session[:intended_controller]
      redirect_to :action => session[:intended_action], :controller => session[:intended_controller]
    end
    if session[:user]
      redirect_to index_url
    end
    if request.post?
      if params[:openid]
        c = OpenID::Consumer.new(session,$OPENID_STORE)
        r = c.begin(params[:openid])
        logger.debug(["c:",c])
        logger.debug(["r:",r])
        logger.debug(["r:",r.inspect()])
        logger.debug(["r.status:",r.status])
        if r.status == "success"
          url = r.redirect_url("http://#{HOST}",openid_signedin_url())
          logger.debug(["url:",url])
          redirect_to(url)
          return
        else
          flash[:error] = "We couldn't determine which identity provider to send you to.  Please check your URL."
          redirect_to( signin_url + "?openid=" + params[:openid] )
          return
        end
      else
        flash[:error] = "You have to provide your OpenID.  That's an URL that starts with 'http://' that contains your identity information."
      end
    end
  end
  
  def signedin
    c = OpenID::Consumer.new(session,$OPENID_STORE)
    r = c.complete(params)
    logger.debug(["complete r:",r])
    
    if r.identity_url && r.service && r.status == "success"
      logger.debug(["r.identity_url:",r.identity_url," | r.service:",r.service])
      user = User.find_by_loginid(r.identity_url,:conditions => "logintype = 'OpenID'")
      logger.debug(["user:",user])
      unless user
        user = User.new(
          :loginid => r.identity_url,
          :logintype => "OpenID"
        )
        hcard = HCard.find(r.identity_url)
        if hcard
          logger.debug(["hcard:",hcard.inspect()])
          if hcard.is_a?(Array)
            hcard = hcard[0]
          end
          if hcard.properties.include?('fn')
            user.name = hcard.fn
          end
          if hcard.properties.include?('email')
            user.email=hcard.email
          end
          if hcard.properties.include?('url')
            user.url = hcard.url
          end
          if hcard.properties.include?('org')
            user.org = hcard.org
          end
          if hcard.properties.include?('title')
            user.title = hcard.title
          end
          if hcard.properties.include?('photo')
            user.photo = hcard.photo
          end
        end
        
        user.save!
        session[:user] = user.id
        flash[:notice] = "Welcome!"
        redirect_to edit_url
      else
        session[:user] = user.id
        flash[:notice] = "Welcome back!"
        redirect_to index_url
      end
      
      
    elsif r.status == "cancel"
      flash[:error] = "You cancelled the login process.  If you want to try again, enter your OpenID and click the login button."
      redirect_to :action => "signin"
    else
      logger.debug(["error response:",r.msg])
      flash[:error] = "Whoops!  Something broke in this here login process.  Please give it another shot."
      redirect_to :action => "signin"
    end
    return
  end
  
  def signout
    session[:user] = nil
    flash[:notice] = "You've been signed out."
    redirect_to(index_url)
  end
  
end
