require "mofo"
class UserController < ApplicationController
  layout "profile"
  before_filter :check_authentication, :only => ["edit", "get_hcard"]
  before_filter :get_user
  def index
    @users = User.find(:all)
  end
  
  def profile
    if params[:id]
      begin
        @user = User.find(params[:id])
      rescue ActiveRecord::RecordNotFound
        flash[:error] = "We couldn't find that user!"
        redirect_to :action => :index
        return
      end
    end
  end
  
  def edit
    if request.post?
      @user.update_attributes(params[:user])
      @user.save!
      flash[:notice] = "We saved your profile.  Yay!"
      redirect_to(:action => "profile",:id => @user.id)
    end
  end
  
  def about
    
  end
  
  def get_hcard
    url = params["hcard_url"]
    
    if url.blank?
      flash[:error] = "We can't get an hcard from an URL that doesn't exist, silly."
    else
      begin
        hcard = HCard.find(url)
      rescue Timeout::Error
        flash[:error] = "Timed out trying to get your hcard..."
      else
        unless hcard.blank?
          logger.debug(["hcard:|",hcard,"|"])
          if hcard.is_a?(Array)
            hcard = hcard[0]
          end

          logger.debug(["hcard properties:",hcard.properties])

          if hcard.properties.include?('fn')
            @user.name = hcard.fn
          end
          if hcard.properties.include?('email')
            @user.email=hcard.email
          end
          if hcard.properties.include?('url')
            @user.url = hcard.url
          end
          if hcard.properties.include?('org')
            @user.org = hcard.org
          end
          if hcard.properties.include?('title')
            @user.title = hcard.title
          end
          if hcard.properties.include?('photo')
            @user.photo = hcard.photo
          end

          @user.save!

          flash[:notice] = "Successfully updated your profile with the new hcard data!"

        else
          flash[:error] = "We couldn't find an hcard on that page, maybe it's the wrong URL?"
        end
      end
      
    end
    
    redirect_to(edit_url)
  end
end
