ActionController::Routing::Routes.draw do |map|
  # The priority is based upon order of creation: first created -> highest priority.
  
  # Sample of regular route:
  # map.connect 'products/:id', :controller => 'catalog', :action => 'view'
  # Keep in mind you can assign values other than :controller and :action

  # Sample of named route:
  # map.purchase 'products/:id/purchase', :controller => 'catalog', :action => 'purchase'
  # This route can be invoked with purchase_url(:id => product.id)

  # You can have the root of your site routed by hooking up '' 
  # -- just remember to delete public/index.html.
  # map.connect '', :controller => "welcome"

  # Allow downloading Web Service WSDL as a file with an extension
  # instead of a file named 'wsdl'
  map.connect ':controller/service.wsdl', :action => 'wsdl'

  map.index "",
    :controller => "signin",
    :action => "index"

  map.signin "signin/signin",
    :controller => "signin",
    :action => "signin"
  
  map.openid_signedin "signin/signedin",
    :controller => "signin",
    :action => "signedin"
    
  map.signout "signin/signout",
    :controller => "signin",
    :action => "signout"
    
  map.edit "user/edit",
    :controller => "user",
    :action => "edit"
    
  map.profile "user/profile/:id",
    :controller => "user",
    :action => "profile"

  # Install the default route as the lowest priority.
  map.connect ':controller/:action/:id.:format'
  map.connect ':controller/:action/:id'
end
